# Ignite UI for Angular - From Infragistics

[![Build Status](https://travis-ci.org/IgniteUI/igniteui-js-blocks.svg?branch=master)](https://travis-ci.org/IgniteUI/igniteui-js-blocks)
[![Coverage Status](https://coveralls.io/repos/github/IgniteUI/igniteui-js-blocks/badge.svg?branch=master)](https://coveralls.io/github/IgniteUI/igniteui-js-blocks?branch=master)
[![NPM version](https://img.shields.io/npm/v/igniteui-js-blocks.svg?style=flat)](https://www.npmjs.com/package/igniteui-js-blocks)

### [**View samples here**](http://139.59.168.161)

**Note:** as of January 3rd 2017 the license for this project has changed from MIT to Apache 2.0. For more information about these licenses please click [here](http://choosealicense.com/licenses/)

Material-based UI Components and supporting directives for [Angular](https://angular.io/) by Infragistics including samples and tests. Source files under the [`src`](https://github.com/IgniteUI/igniteui-js-blocks/tree/master/src) folder.

Current list of controls include:


| *Components*          | Status              | Docs                                                                                            |     | *Directives*  | Status        | Docs                                                                                                  |
| :-:                   | :-:                 | :-:                                                                                             | :-: | :-:           | :-:           | :-:                                                                                                   |
| **avatar**            |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/avatar/README.md)       |     | **button**    |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/button/README.md)             |
| **badge**             |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/badge/README.md)        |     | **filter**    |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/directives/README-FILTER.md)  |
| **carousel**          |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/carousel/README.md)     |     | **ripple**    |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/directives/README-RIPPLE.md)  |
| **list**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/list/README.md)         |     | **input**     |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/input/README.md)              |
| **navbar**            |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/navbar/README.md)       |     | **label**     |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/label/README.md)              |
| **tabbar**            |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/tabbar/README.md)       |     | **layout**    |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/layout/README.md)             |
| **dialog**            |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/dialog/README.md)       |     |               |               |                                                                                                       |
| **snackbar**          |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/snackbar/README.md)     |     |               |               |                                                                                                       |
| **toast**             |     Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/toast/README.md)     |     |               |               |                                                                                                       |
| **navigation drawer** |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/navigation-drawer/README.md)    |     |               |               |                                                                                                       |
| **radio**             |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/radio/README.md)        |     |               |               |                                                                                                       |
| **checkbox**          |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/checkbox/README.md)     |     |               |               |                                                                                                       |
| **switch**            |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/switch/README.md)       |     |               |               |                                                                                                       |
| **scroll**            |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/scroll/README.md)       |     |               |               |                                                                                                       |
| **linear progress**    |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/progressbar/README.md)  |     |               |               |                                                                                                       |
| **circular progress** |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/progressbar/README.md)  |     |               |               |                                                                                                       |
| **icon**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/tree/master/src/icon/README.md)         |     |               |               |                                                                                                       |
| **card**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/card/README.md)         |     |               |               |                                                                                                       |
| **grid**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/grid/README.md)         |     |               |               |                                                                                                       |
| **slider**            |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/slider/README.md)       |     |               |               |                                                                                                       |
| **calendar**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/tree/master/src/calendar/README.md)         |     |               |               |                                                                                                       |
| **buttonGroup**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/buttonGroup/README.md)      |               |               |                                                                                                       |
| **dataContainer**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/data-operations/README-DATACONTAINER.md)      |               |               |                                                                                                       |
| **dataUtil**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/data-operations/README-DATAUTIL.md)      |               |               |                                                                                                       |
| **datePicker**              |           Available | [Readme](https://github.com/IgniteUI/igniteui-js-blocks/blob/master/src/date-picker/README.md)      |               |               |                                                                                                       |

## Setup
From the root folder run:

```
npm install
```

## Build Library
In case your editor cannot auto-compile the TypeScript files (VS, VS Code, others with plugins)
there's a configured npm command in place to run the compiler:

For both ESM and UMD builds
```
npm run build
npm run build:watch // run in watch mode
```

ESM build only
```
npm run build:esm
npm run build:esm:watch // run in watch mode
```

UMD build only
```
npm run build:umd
npm run build:umd:watch // run in watch mode
```

## Run Demos

The `demos` directory contains a sample application showcasing the components and directives of the library.
If you want to run the application make sure to install the application dependencies:
```
cd demos && npm install
```

Run the following command from the root directory of your repository.
This will open the demos application in your preferred browser. Any changes in the
application code will trigger a rebuild of the application.
```
npm run start:demos
```

In case you want to explore/experiment with the library code start the demo application
with:
```
npm run start:dev
```
It will watch both the `src` and `demos` directories and will rebuild both the library and the application.

## NPM Package

You can include Ignite UI JS Blocks in your project as a dependency using the NPM package.

`npm install igniteui-js-blocks --save-dev`

## Contributing
[Coding Guidelines](../../wiki//Coding-guidelines-for-Ignite-UI-JS-Blocks)

[General Naming Guidelines](../../wiki//General-Naming-Guidelines-for-Ignite-UI-JS-Blocks)


## Quickstart App
[IgniteUI JS Blocks Quickstart app](https://github.com/IgniteUI/igniteui-js-blocks-quickstart)
This repository is a fork of the Angular QuickStart Source and has been updated to demonstrate how to include and use components from the Ignite UI JS Blocks. It basically follows the shortest path to bootstrap writing the application with IgniteUI JS Blocks:

- Fork the [the angular quickstart](https://github.com/angular/quickstart)
- Install IgniteUI JS Blocks from npm using `npm install igniteui-js-blocks --save-dev`
- Update the views with sample JS Blocks controls.

## Demo App
[Warehouse Picklist App](https://github.com/IgniteUI/warehouse-js-blocks)
