import { Directive, ElementRef, Input, NgModule, Renderer2 } from "@angular/core";
var IgxButton = (function () {
    function IgxButton(_el, _renderer) {
        this._el = _el;
        this._renderer = _renderer;
        this._type = "flat";
        this._cssClass = "igx-button";
    }
    Object.defineProperty(IgxButton.prototype, "type", {
        set: function (value) {
            this._type = value || this._type;
            this._renderer.addClass(this._el.nativeElement, this._cssClass + "--" + this._type);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxButton.prototype, "color", {
        set: function (value) {
            this._color = value || this._el.nativeElement.style.color;
            this._renderer.setStyle(this._el.nativeElement, "color", this._color);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxButton.prototype, "background", {
        set: function (value) {
            this._backgroundColor = value || this._backgroundColor;
            this._renderer.setStyle(this._el.nativeElement, "background", this._backgroundColor);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxButton.prototype, "label", {
        set: function (value) {
            this._label = value || this._label;
            this._renderer.setAttribute(this._el.nativeElement, "aria-label", this._label);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxButton.prototype, "disabled", {
        set: function (val) {
            val = !!val;
            if (val) {
                this._renderer.addClass(this._el.nativeElement, this._cssClass + "--disabled");
            }
            else {
                this._renderer.removeClass(this._el.nativeElement, this._cssClass + "--disabled");
            }
        },
        enumerable: true,
        configurable: true
    });
    IgxButton.decorators = [
        { type: Directive, args: [{
                    host: {
                        role: "button"
                    },
                    selector: "[igxButton]"
                },] },
    ];
    /** @nocollapse */
    IgxButton.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
    ]; };
    IgxButton.propDecorators = {
        "type": [{ type: Input, args: ["igxButton",] },],
        "color": [{ type: Input, args: ["igxButtonColor",] },],
        "background": [{ type: Input, args: ["igxButtonBackground",] },],
        "label": [{ type: Input, args: ["igxLabel",] },],
        "disabled": [{ type: Input },],
    };
    return IgxButton;
}());
export { IgxButton };
var IgxButtonModule = (function () {
    function IgxButtonModule() {
    }
    IgxButtonModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxButton],
                    exports: [IgxButton]
                },] },
    ];
    /** @nocollapse */
    IgxButtonModule.ctorParameters = function () { return []; };
    return IgxButtonModule;
}());
export { IgxButtonModule };
//# sourceMappingURL=button.directive.js.map