import { Component, EventEmitter, Input, NgModule, Output, ViewChild } from "@angular/core";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
var noop = function () { };
var ɵ0 = noop;
var nextId = 0;
var IgxCheckbox = (function () {
    function IgxCheckbox() {
        this.focused = false;
        this.id = "igx-checkbox-" + nextId++;
        this.disabled = false;
        this.tabindex = null;
        this.checked = false;
        this.change = new EventEmitter();
        this._onTouchedCallback = noop;
        this._onChangeCallback = noop;
    }
    IgxCheckbox.prototype.onChange = function (event) {
        if (this.disabled) {
            return;
        }
        this.checked = !this.checked;
        this._onChangeCallback(this.checked);
        this.change.emit(event);
    };
    IgxCheckbox.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxCheckbox.prototype.onBlur = function (event) {
        this.focused = false;
        this._onTouchedCallback();
    };
    IgxCheckbox.prototype.writeValue = function (value) {
        if (this.disabled) {
            return;
        }
        this._value = value;
        this.checked = !!this._value;
    };
    IgxCheckbox.prototype.registerOnChange = function (fn) { this._onChangeCallback = fn; };
    IgxCheckbox.prototype.registerOnTouched = function (fn) { this._onTouchedCallback = fn; };
    IgxCheckbox.decorators = [
        { type: Component, args: [{
                    providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: IgxCheckbox, multi: true }],
                    selector: "igx-checkbox",
                    styles: ["\n      @-webkit-keyframes scale-in-center{0%{-webkit-transform:scale(0);transform:scale(0);opacity:1}100%{-webkit-transform:scale(1);transform:scale(1);opacity:1}}@keyframes scale-in-center{0%{-webkit-transform:scale(0);transform:scale(0);opacity:1}100%{-webkit-transform:scale(1);transform:scale(1);opacity:1}}.igx-control__cbx ~ .igx-control__label{display:inline-block;position:relative;cursor:pointer;min-height:20px;line-height:20px;font-size:1em;font-weight:400;color:rgba(0,0,0,0.87);padding-left:1.5em;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-tap-highlight-color:transparent;overflow:hidden}.igx-control__cbx ~ .igx-control__label::after{position:absolute;content:'';top:0;left:0;border-radius:2px}.igx-control__cbx:not(:checked) ~ .igx-control__label::after,.igx-control__cbx:checked ~ .igx-control__label::after{width:20px;height:20px}.tick{position:absolute;top:0;left:0;width:20px;height:20px;padding:3px 2px 2px;stroke:none;stroke-linecap:round;stroke-width:3px;fill:none;z-index:1}.igx-control__cbx:checked ~ .igx-control__label .tick{-webkit-animation:\"scale-in-center\" 0.3s cubic-bezier(0.175, 0.885, 0.32, 1.275) both;animation:\"scale-in-center\" 0.3s cubic-bezier(0.175, 0.885, 0.32, 1.275) both;stroke:#fff}.igx-control__cbx:not(:checked) ~ .igx-control__label::after{border:2px solid rgba(0,0,0,0.54)}.igx-control__cbx:checked ~ .igx-control__label::after{background-color:#e41c77;border:2px solid #e41c77}.igx-control__cbx:disabled ~ .igx-control__label{color:rgba(0,0,0,0.38);pointer-events:none}.igx-control__cbx:disabled:checked ~ .igx-control__label::after{background-color:rgba(0,0,0,0.38);border-color:rgba(0,0,0,0.38)}.igx-control__cbx:disabled:not(:checked) ~ .igx-control__label::after{border-color:rgba(0,0,0,0.38)}.igx-control{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;padding:8px 0}.igx-control__cbx{margin:0;position:absolute;opacity:0;z-index:-1;width:0;height:0;left:0;overflow:hidden;pointer-events:none}\n    "],
                    template: "\n      <div class=\"igx-control\">\n          <input class=\"igx-control__cbx\" #checkbox type=\"checkbox\"\n              [attr.id]=\"id\"\n              [attr.name]=\"name\"\n              [attr.value]=\"value\"\n              [attr.tabindex]=\"tabindex\"\n              [attr.disabled]=\"disabled ? true : null\"\n              [checked]=\"checked\"\n              [attr.aria-checked]=\"checked\"\n              (change)=\"onChange($event)\"\n              (focus)=\"onFocus($event)\"\n              (blur)=\"onBlur($event)\">\n          <label class=\"igx-control__label\" [attr.for]=\"id\">\n              <svg class=\"tick\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 22 22\">\n                  <g fill=\"none\" fill-rule=\"evenodd\">\n                      <path class=\"tick__mark\" d=\"M2 10.8l5 5L18.8 4\"/>\n                  </g>\n              </svg>\n              <ng-content></ng-content>\n          </label>\n      </div>\n    "
                },] },
    ];
    /** @nocollapse */
    IgxCheckbox.ctorParameters = function () { return []; };
    IgxCheckbox.propDecorators = {
        "value": [{ type: Input },],
        "id": [{ type: Input },],
        "name": [{ type: Input },],
        "disabled": [{ type: Input },],
        "tabindex": [{ type: Input },],
        "checked": [{ type: Input },],
        "change": [{ type: Output },],
        "nativeCheckbox": [{ type: ViewChild, args: ["checkbox",] },],
    };
    return IgxCheckbox;
}());
export { IgxCheckbox };
var IgxCheckboxModule = (function () {
    function IgxCheckboxModule() {
    }
    IgxCheckboxModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxCheckbox],
                    exports: [IgxCheckbox]
                },] },
    ];
    /** @nocollapse */
    IgxCheckboxModule.ctorParameters = function () { return []; };
    return IgxCheckboxModule;
}());
export { IgxCheckboxModule };
export { ɵ0 };
//# sourceMappingURL=checkbox.component.js.map