import { Component, ContentChild, Input } from "@angular/core";
import { DataType } from "../data-operations/data-util";
import { FilteringCondition } from "../data-operations/filtering-condition";
import { IgxCellFooterTemplateDirective, IgxCellHeaderTemplateDirective, IgxCellTemplateDirective } from "./grid.common";
var IgxColumnComponent = (function () {
    function IgxColumnComponent() {
        this.header = "";
        this.sortable = false;
        this.editable = false;
        this.filtering = false;
        this.hidden = false;
        this.movable = false;
        this.filteringCondition = FilteringCondition.string.contains;
        this.filteringIgnoreCase = true;
        this.dataType = DataType.String;
    }
    IgxColumnComponent.prototype.ngAfterContentInit = function () {
        if (this.cellTemplate) {
            this.bodyTemplate = this.cellTemplate.template;
        }
        if (this.headTemplate) {
            this.headerTemplate = this.headTemplate.template;
        }
        if (this.footTemplate) {
            this.footerTemplate = this.footTemplate.template;
        }
    };
    IgxColumnComponent.decorators = [
        { type: Component, args: [{
                    selector: "igx-column",
                    template: ""
                },] },
    ];
    /** @nocollapse */
    IgxColumnComponent.ctorParameters = function () { return []; };
    IgxColumnComponent.propDecorators = {
        "field": [{ type: Input },],
        "header": [{ type: Input },],
        "sortable": [{ type: Input },],
        "editable": [{ type: Input },],
        "filtering": [{ type: Input },],
        "hidden": [{ type: Input },],
        "movable": [{ type: Input },],
        "width": [{ type: Input },],
        "index": [{ type: Input },],
        "filteringCondition": [{ type: Input },],
        "filteringIgnoreCase": [{ type: Input },],
        "dataType": [{ type: Input },],
        "cellTemplate": [{ type: ContentChild, args: [IgxCellTemplateDirective,] },],
        "headTemplate": [{ type: ContentChild, args: [IgxCellHeaderTemplateDirective,] },],
        "footTemplate": [{ type: ContentChild, args: [IgxCellFooterTemplateDirective,] },],
    };
    return IgxColumnComponent;
}());
export { IgxColumnComponent };
//# sourceMappingURL=column.component.js.map