import { EmbeddedViewRef, EventEmitter, OnDestroy, OnInit, TemplateRef, ViewContainerRef } from "@angular/core";
import { SortingDirection } from "../data-operations/sorting-expression.interface";
import { IgxColumnComponent } from "./column.component";
export interface IgxColumnFilteredEvent {
    value: string;
    column: IgxColumnComponent;
}
export interface IgxColumnSortedEvent {
    column: IgxColumnComponent;
    direction: any;
}
export declare class IgxCellTemplateDirective {
    template: TemplateRef<any>;
    constructor(template: TemplateRef<any>);
}
export declare class IgxCellHeaderTemplateDirective {
    template: TemplateRef<any>;
    constructor(template: TemplateRef<any>);
}
export declare class IgxCellFooterTemplateDirective {
    template: TemplateRef<any>;
    constructor(template: TemplateRef<any>);
}
export declare class IgxColumnSortingDirective {
    column: IgxColumnComponent;
    sortDirection: SortingDirection;
    protected onSort: EventEmitter<IgxColumnSortedEvent>;
    readonly off: boolean;
    readonly asc: boolean;
    readonly desc: boolean;
    protected onClick(event: Event): void;
}
export declare class IgxCellBodyComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: IgxColumnComponent;
    item: any;
    rowIndex: number;
    row: any;
    protected view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class IgxCellHeaderComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: IgxColumnComponent;
    colIndex: number;
    protected view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class IgxCellFooterComponent implements OnInit, OnDestroy {
    viewContainer: ViewContainerRef;
    column: IgxColumnComponent;
    colIndex: number;
    protected view: EmbeddedViewRef<any>;
    constructor(viewContainer: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
export declare class IgxColumnFilteringComponent {
    column: IgxColumnComponent;
    value: string;
    hidden: boolean;
    protected onFilter: EventEmitter<IgxColumnFilteredEvent>;
    show(): void;
    hide(): void;
    toggle(): void;
    protected filterData(event: any): void;
}
