import { Component, EventEmitter, Input, Output } from "@angular/core";
var IgxPaginatorComponent = (function () {
    function IgxPaginatorComponent() {
        this.currentPage = 0;
        this.onPageChange = new EventEmitter();
    }
    Object.defineProperty(IgxPaginatorComponent.prototype, "isLast", {
        get: function () {
            return this.currentPage + 1 >= this.totalPages;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPaginatorComponent.prototype, "isFirst", {
        get: function () {
            return this.currentPage === 0;
        },
        enumerable: true,
        configurable: true
    });
    IgxPaginatorComponent.prototype.paginate = function (page) {
        var event = {
            currentPage: page,
            perPage: this.perPage,
            totalPages: this.totalPages
        };
        this.onPageChange.emit(event);
    };
    IgxPaginatorComponent.decorators = [
        { type: Component, args: [{
                    selector: "igx-paginator",
                    styles: [
                        ".igx-paginator {\n            display: flex;\n            flex-direction: row;\n            align-items: center;\n            justify-content: center;\n            align-content: center;\n            margin: 1rem auto;\n            width: 100%;\n        }\n        .igx-paginator span {\n            padding: 1rem;\n        }\n        "
                    ],
                    template: "\n      <div class=\"igx-paginator\">\n          <button [disabled]=\"isFirst\" (click)=\"paginate(0)\" igxButton=\"icon\" igxRipple igxRippleCentered=\"true\">\n              <igx-icon fontSet=\"material\" name=\"first_page\"></igx-icon>\n          </button>\n          <button [disabled]=\"isFirst\" (click)=\"paginate(currentPage - 1)\" igxButton=\"icon\" igxRipple igxRippleCentered=\"true\">\n              <igx-icon fontSet=\"material\" name=\"chevron_left\"></igx-icon>\n          </button>\n          <span>{{ currentPage + 1}} of {{ totalPages }}</span>\n          <button (click)=\"paginate(currentPage + 1)\" igxRipple igxRippleCentered=\"true\" [disabled]=\"isLast\" igxButton=\"icon\">\n              <igx-icon fontSet=\"material\" name=\"chevron_right\"></igx-icon>\n          </button>\n          <button (click)=\"paginate(totalPages - 1)\" igxRipple igxRippleCentered=\"true\" [disabled]=\"isLast\" igxButton=\"icon\">\n              <igx-icon fontSet=\"material\" name=\"last_page\"></igx-icon>\n          </button>\n      </div>\n    "
                },] },
    ];
    /** @nocollapse */
    IgxPaginatorComponent.ctorParameters = function () { return []; };
    IgxPaginatorComponent.propDecorators = {
        "currentPage": [{ type: Input },],
        "totalPages": [{ type: Input },],
        "perPage": [{ type: Input },],
        "onPageChange": [{ type: Output },],
    };
    return IgxPaginatorComponent;
}());
export { IgxPaginatorComponent };
//# sourceMappingURL=paginator.component.js.map