import { CommonModule } from "@angular/common";
import { Component, ElementRef, Input, NgModule, ViewChild } from "@angular/core";
var IgxIcon = (function () {
    function IgxIcon(el) {
        this.el = el;
        this.font = "material";
        this.active = "true";
    }
    Object.defineProperty(IgxIcon.prototype, "fontSet", {
        set: function (value) {
            this.font = value || this.font;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxIcon.prototype, "isActive", {
        set: function (value) {
            this.active = value || this.active;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxIcon.prototype, "color", {
        set: function (value) {
            this.iconColor = value;
            this.el.nativeElement.style.color = this.iconColor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxIcon.prototype, "name", {
        set: function (value) {
            this.iconName = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxIcon.prototype, "getFontSet", {
        get: function () {
            return this.font;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxIcon.prototype, "getActive", {
        get: function () {
            if (this.active.toLowerCase() === "true") {
                return true;
            }
            else if (this.active.toLowerCase() === "false") {
                return false;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxIcon.prototype, "getIconColor", {
        get: function () {
            return this.iconColor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxIcon.prototype, "getIconName", {
        get: function () {
            return this.iconName;
        },
        enumerable: true,
        configurable: true
    });
    IgxIcon.decorators = [
        { type: Component, args: [{
                    selector: "igx-icon",
                    styles: ["\n      .igx-icon{display:-webkit-box;display:-ms-flexbox;display:flex;position:relative;font-size:1.5em;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center}.igx-icon--inactive{color:rgba(0,0,0,0.38)}\n    "],
                    template: "\n      <span class=\"igx-icon\" [class.igx-icon--inactive]=\"!getActive\">\n          <i #icon *ngIf=\"getFontSet == 'material'\" class=\"material-icons\">\n              {{ getIconName }}\n          </i>\n      </span>\n    "
                },] },
    ];
    /** @nocollapse */
    IgxIcon.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    IgxIcon.propDecorators = {
        "themeIcon": [{ type: ViewChild, args: ["icon",] },],
        "fontSet": [{ type: Input, args: ["fontSet",] },],
        "isActive": [{ type: Input, args: ["isActive",] },],
        "color": [{ type: Input, args: ["color",] },],
        "name": [{ type: Input, args: ["name",] },],
    };
    return IgxIcon;
}());
export { IgxIcon };
var IgxIconModule = (function () {
    function IgxIconModule() {
    }
    IgxIconModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxIcon],
                    exports: [IgxIcon],
                    imports: [CommonModule]
                },] },
    ];
    /** @nocollapse */
    IgxIconModule.ctorParameters = function () { return []; };
    return IgxIconModule;
}());
export { IgxIconModule };
//# sourceMappingURL=icon.component.js.map