import { ElementRef, EventEmitter, OnDestroy, OnInit, QueryList, Renderer2 } from "@angular/core";
export interface IListChild {
    index: number;
}
export declare enum IgxListPanState {
    NONE = 0,
    LEFT = 1,
    RIGHT = 2,
}
export declare class IgxList {
    private element;
    children: QueryList<IgxListItem>;
    allowLeftPanning: boolean;
    allowRightPanning: boolean;
    hasNoItemsTemplate: boolean;
    emptyListImage: string;
    emptyListMessage: string;
    emptyListButtonText: string;
    emptyListButtonClick: EventEmitter<{}>;
    onLeftPan: EventEmitter<{}>;
    onRightPan: EventEmitter<{}>;
    onPanStateChange: EventEmitter<{}>;
    readonly innerStyle: string;
    private _innerStyle;
    readonly items: IgxListItem[];
    readonly headers: IgxListItem[];
    constructor(element: ElementRef);
    private onEmptyListButtonClicked(event);
}
export declare class IgxListItem implements OnInit, OnDestroy, IListChild {
    private list;
    private _renderer;
    element: ElementRef;
    hidden: boolean;
    role: any;
    isHeader: boolean;
    href: string;
    options: object[];
    readonly innerStyle: string;
    private _panState;
    private _FRACTION_OF_WIDTH_TO_TRIGGER_GRIP;
    private _innerStyle;
    private _previousPanDeltaX;
    readonly panState: IgxListPanState;
    readonly index: number;
    readonly width: any;
    left: number;
    readonly maxLeft: number;
    readonly maxRight: any;
    constructor(list: IgxList, _renderer: Renderer2);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private _addEventListeners();
    private panStart(ev);
    private panMove(ev);
    private panEnd(ev);
    private performMagneticGrip();
}
export declare class IgxListModule {
}
