import { AfterViewInit, ElementRef, EventEmitter, OnChanges, Renderer2 } from "@angular/core";
export declare abstract class BaseProgress {
    protected _valueInPercent: number;
    protected _prevValue: number;
    protected _currValue: number;
    protected max: any;
    protected value: any;
    readonly valueInPercent: number;
    getValue(): number;
    getPercentValue(): number;
    protected instantiateValAnimation(prevVal: number, currVal: number, max: number): void;
    protected startAnimation(interval: number, circular?: ElementRef, percentage?: number): void;
}
export declare class IgxLinearProgressBar extends BaseProgress implements OnChanges {
    private elementRef;
    private renderer;
    max: number;
    striped: boolean;
    type: string;
    value: number;
    onProgressChanged: EventEmitter<{}>;
    protected _valueInPercent: number;
    private _interval;
    private _linearBar;
    constructor(elementRef: ElementRef, renderer: Renderer2);
    ngOnChanges(changes: any): void;
}
export declare class IgxCircularProgressBar extends BaseProgress implements AfterViewInit, OnChanges {
    private elementRef;
    private renderer;
    max: number;
    value: number;
    onProgressChanged: EventEmitter<{}>;
    protected _valueInPercent: number;
    private _radius;
    private _circumference;
    private _interval;
    private _percentage;
    private _progress;
    private _svgCircle;
    private _svgText;
    constructor(elementRef: ElementRef, renderer: Renderer2);
    ngOnChanges(changes: any): void;
    ngAfterViewInit(): void;
    private getProgress(percentage);
}
export declare function getValueInRange(value: number, max: number, min?: number): number;
export declare function convertValueInPercent(value: number, max: number): number;
export declare class IgxProgressBarModule {
}
