var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { CommonModule } from "@angular/common";
import { Component, ElementRef, EventEmitter, Input, NgModule, Output, Renderer2, ViewChild } from "@angular/core";
var BaseProgress = (function () {
    function BaseProgress() {
    }
    Object.defineProperty(BaseProgress.prototype, "valueInPercent", {
        get: function () {
            return this._valueInPercent;
        },
        enumerable: true,
        configurable: true
    });
    BaseProgress.prototype.getValue = function () {
        return getValueInRange(this.value, this.max);
    };
    BaseProgress.prototype.getPercentValue = function () {
        return convertValueInPercent(this.getValue(), this.max);
    };
    BaseProgress.prototype.instantiateValAnimation = function (prevVal, currVal, max) {
        // Validate current and previous value to be in range [0...max]
        var validatePrevValue = getValueInRange(prevVal, max) || 0;
        var validateCurrValue = getValueInRange(currVal, max) || 0;
        // Get prev progress value in percent
        this._valueInPercent = convertValueInPercent(validatePrevValue, max);
        // Get previous value in percent
        this._prevValue = convertValueInPercent(validatePrevValue, max);
        // Get current value in percent
        this._currValue = convertValueInPercent(validateCurrValue, max);
    };
    BaseProgress.prototype.startAnimation = function (interval, circular, percentage) {
        if (circular === void 0) { circular = null; }
        if (percentage === void 0) { percentage = 0; }
        // Change progress bar percent value
        var timer = setInterval(function animateBar() {
            if (this._valueInPercent >= this._currValue) {
                clearInterval(timer);
                // Object that passed to the event
                var changedValues = {
                    currentValue: this._currValue,
                    previousValue: this._prevValue
                };
                this.onProgressChanged.emit(changedValues);
                if (circular) {
                    this.renderer.setStyle(circular.nativeElement, "strokeDashoffset", percentage);
                }
            }
            else {
                // Update progress bar percent value
                this._valueInPercent++;
            }
        }.bind(this), interval);
    };
    return BaseProgress;
}());
export { BaseProgress };
var IgxLinearProgressBar = (function (_super) {
    __extends(IgxLinearProgressBar, _super);
    function IgxLinearProgressBar(elementRef, renderer) {
        var _this = _super.call(this) || this;
        _this.elementRef = elementRef;
        _this.renderer = renderer;
        _this.max = 100;
        _this.striped = false;
        _this.type = "default";
        _this.value = 0;
        _this.onProgressChanged = new EventEmitter();
        _this._valueInPercent = 0;
        _this._interval = 15;
        return _this;
    }
    IgxLinearProgressBar.prototype.ngOnChanges = function (changes) {
        if (this._linearBar) {
            if (changes.value) {
                _super.prototype.instantiateValAnimation.call(this, changes.value.previousValue, changes.value.currentValue, this.max);
                _super.prototype.startAnimation.call(this, this._interval);
            }
        }
    };
    IgxLinearProgressBar.decorators = [
        { type: Component, args: [{
                    selector: "igx-linear-bar",
                    styles: ["\n      .progress-linear{display:-webkit-box;display:-ms-flexbox;display:flex;position:relative;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-flow:column nowrap;flex-flow:column nowrap;width:100%;height:5px;margin-bottom:32px;background:rgba(3,117,190,0.1)}.progress-linear__bar,.progress-linear__bar--default,.progress-linear__bar--danger,.progress-linear__bar--warning,.progress-linear__bar--info,.progress-linear__bar--success{width:inherit;height:inherit;-ms-flex-item-align:start;align-self:flex-start}.progress-linear--striped>div{background-image:linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-size:40px 40px}.progress-linear__value{margin:10px 5px;position:absolute;color:rgba(0,0,0,0.74);font-size:.875em;-ms-flex-item-align:start;align-self:flex-start;font-weight:600}.progress-linear__bar--default{background-color:#0375be}.progress-linear__bar--danger{background-color:#f44336}.progress-linear__bar--warning{background-color:#fbb13c}.progress-linear__bar--info{background-color:#e41c77}.progress-linear__bar--success{background-color:#4caf50}.progress-circular{width:100%;height:100%}.progress-circular__innercircle{stroke-width:4;fill:transparent;stroke:#0375be;stroke-opacity:.1}.progress-circular__circle{fill:transparent;stroke:url(\"#linear\");stroke-width:6;stroke-linecap:round;stroke-dashoffset:289;stroke-dasharray:289;-webkit-transform-origin:50% 50%;transform-origin:50% 50%;-webkit-transform:rotate(-90deg);transform:rotate(-90deg)}.progress-circular__text{font-family:'Titillium Web', sans-serif;font-size:2em;fill:rgba(0,0,0,0.74)}\n    "],
                    template: "\n      <div class=\"progress-linear\"\n          [class.progress-linear--striped]=\"striped\">\n          <div #linearBar role=\"progressbar\" class=\"progress-linear__bar{{type ? '--' + type : ''}}\"\n              aria-valuemin=\"0\"\n              [attr.aria-valuemax]=\"max\"\n              [attr.aria-valuenow]=\"getValue()\"\n              [style.width.%]=\"valueInPercent || getPercentValue()\">\n              <ng-content></ng-content>\n          </div>\n          <span class=\"progress-linear__value\">{{valueInPercent || getPercentValue()}}%</span>\n      </div>\n    "
                },] },
    ];
    /** @nocollapse */
    IgxLinearProgressBar.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
    ]; };
    IgxLinearProgressBar.propDecorators = {
        "max": [{ type: Input },],
        "striped": [{ type: Input },],
        "type": [{ type: Input },],
        "value": [{ type: Input },],
        "onProgressChanged": [{ type: Output },],
        "_valueInPercent": [{ type: Input },],
        "_linearBar": [{ type: ViewChild, args: ["linearBar",] },],
    };
    return IgxLinearProgressBar;
}(BaseProgress));
export { IgxLinearProgressBar };
var IgxCircularProgressBar = (function (_super) {
    __extends(IgxCircularProgressBar, _super);
    function IgxCircularProgressBar(elementRef, renderer) {
        var _this = _super.call(this) || this;
        _this.elementRef = elementRef;
        _this.renderer = renderer;
        _this.max = 100;
        _this.value = 0;
        _this.onProgressChanged = new EventEmitter();
        _this._valueInPercent = 0;
        _this._radius = 0;
        _this._circumference = 289;
        _this._interval = 15;
        _this._percentage = 0;
        _this._progress = 0;
        return _this;
    }
    IgxCircularProgressBar.prototype.ngOnChanges = function (changes) {
        if (this._svgCircle) {
            // Validate percentage value to be between [0...100]
            this._percentage = getValueInRange(_super.prototype.getPercentValue.call(this), 100);
            if (changes.value) {
                _super.prototype.instantiateValAnimation.call(this, changes.value.previousValue, changes.value.currentValue, this.max);
                _super.prototype.startAnimation.call(this, this._interval, this._svgCircle, this._percentage);
                // Set frames for the animation
                var FRAMES = [{
                        strokeDashoffset: this.getProgress(this._prevValue),
                        strokeOpacity: (this._prevValue / 100) + .2
                    }, {
                        strokeDashoffset: this.getProgress(this._percentage),
                        strokeOpacity: (this._percentage / 100) + .2
                    }];
                // Animate the svg
                this._svgCircle.nativeElement.animate(FRAMES, {
                    duration: (this._percentage * this._interval) + 400,
                    easing: "ease-out",
                    fill: "forwards"
                });
            }
        }
    };
    IgxCircularProgressBar.prototype.ngAfterViewInit = function () {
        if (this._svgCircle) {
            this._radius = parseInt(this._svgCircle.nativeElement.getAttribute("r"), 10);
            this._circumference = 2 * Math.PI * this._radius;
        }
    };
    IgxCircularProgressBar.prototype.getProgress = function (percentage) {
        return this._circumference - (percentage * this._circumference / 100);
    };
    IgxCircularProgressBar.decorators = [
        { type: Component, args: [{
                    selector: "igx-circular-bar",
                    styles: ["\n      .progress-linear{display:-webkit-box;display:-ms-flexbox;display:flex;position:relative;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:start;-ms-flex-pack:start;justify-content:flex-start;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-flow:column nowrap;flex-flow:column nowrap;width:100%;height:5px;margin-bottom:32px;background:rgba(3,117,190,0.1)}.progress-linear__bar,.progress-linear__bar--default,.progress-linear__bar--danger,.progress-linear__bar--warning,.progress-linear__bar--info,.progress-linear__bar--success{width:inherit;height:inherit;-ms-flex-item-align:start;align-self:flex-start}.progress-linear--striped>div{background-image:linear-gradient(45deg, rgba(255,255,255,0.5) 25%, transparent 25%, transparent 50%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.5) 75%, transparent 75%, transparent);background-size:40px 40px}.progress-linear__value{margin:10px 5px;position:absolute;color:rgba(0,0,0,0.74);font-size:.875em;-ms-flex-item-align:start;align-self:flex-start;font-weight:600}.progress-linear__bar--default{background-color:#0375be}.progress-linear__bar--danger{background-color:#f44336}.progress-linear__bar--warning{background-color:#fbb13c}.progress-linear__bar--info{background-color:#e41c77}.progress-linear__bar--success{background-color:#4caf50}.progress-circular{width:100%;height:100%}.progress-circular__innercircle{stroke-width:4;fill:transparent;stroke:#0375be;stroke-opacity:.1}.progress-circular__circle{fill:transparent;stroke:url(\"#linear\");stroke-width:6;stroke-linecap:round;stroke-dashoffset:289;stroke-dasharray:289;-webkit-transform-origin:50% 50%;transform-origin:50% 50%;-webkit-transform:rotate(-90deg);transform:rotate(-90deg)}.progress-circular__text{font-family:'Titillium Web', sans-serif;font-size:2em;fill:rgba(0,0,0,0.74)}\n    "],
                    template: "\n      <svg #svg class=\"progress-circular\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" version=\"1.1\" viewBox=\"0 0 100 100\" preserveAspectRatio=\"none\"\n          role=\"progressbar\"\n          aria-valuemin=\"0\"\n          [attr.aria-valuemax]=\"max\"\n          [attr.aria-valuenow]=\"getValue()\">\n          <defs>\n              <linearGradient id=\"linear\" x1=\"-10%\" y1=\"0%\" x2=\"50%\" y2=\"150%\">\n              <stop offset=\"0%\"   stop-color=\"#0375BE\"/>\n              <stop offset=\"100%\" stop-color=\"cyan\"/>\n              </linearGradient>\n          </defs>\n          <circle class=\"progress-circular__innercircle\" cx=\"50\" cy=\"50\" r=\"46\"/>\n          <circle #circle class=\"progress-circular__circle\" cx=\"50\" cy=\"50\" r=\"46\"/>\n          <text #text class=\"progress-circular__text\" id=\"myTimer\" text-anchor=\"middle\" x=\"50\" y=\"60\">{{valueInPercent}}%</text>\n      </svg>\n    "
                },] },
    ];
    /** @nocollapse */
    IgxCircularProgressBar.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Renderer2, },
    ]; };
    IgxCircularProgressBar.propDecorators = {
        "max": [{ type: Input },],
        "value": [{ type: Input },],
        "onProgressChanged": [{ type: Output },],
        "_valueInPercent": [{ type: Input },],
        "_svgCircle": [{ type: ViewChild, args: ["circle",] },],
        "_svgText": [{ type: ViewChild, args: ["text",] },],
    };
    return IgxCircularProgressBar;
}(BaseProgress));
export { IgxCircularProgressBar };
export function getValueInRange(value, max, min) {
    if (min === void 0) { min = 0; }
    return Math.max(Math.min(value, max), min);
}
export function convertValueInPercent(value, max) {
    return Math.floor(100 * value / max);
}
var IgxProgressBarModule = (function () {
    function IgxProgressBarModule() {
    }
    IgxProgressBarModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxLinearProgressBar, IgxCircularProgressBar],
                    exports: [IgxLinearProgressBar, IgxCircularProgressBar],
                    imports: [CommonModule]
                },] },
    ];
    /** @nocollapse */
    IgxProgressBarModule.ctorParameters = function () { return []; };
    return IgxProgressBarModule;
}());
export { IgxProgressBarModule };
//# sourceMappingURL=progressbar.component.js.map