import { EventEmitter } from "@angular/core";
import { HammerGestureConfig } from "@angular/platform-browser";
export declare class ScrollHammerGestureManager extends HammerGestureConfig {
    overrides: any;
}
/**
 * Scroll event interface
 */
export interface IgxScrollEvent {
    /**
     * Returns the index of the current top item (zero based).
     * @type {number}
     */
    currentTop: number;
}
export declare class IgxScroll {
    /**
     * Gets the scroll top of the scroll
     * @returns {number}
     */
    readonly scrollTop: number;
    /**
     *  The amount of the actual rendered items in the scroll.
     */
    visibleItemsCount: number;
    /**
     * The total amount of items in that will be virtualized.
     */
    totalItemsCount: number;
    /**
     *  The height for container of the items. By design only items with same heights are supported
     */
    itemHeight: number;
    /**
     * Scroll event executed each time when the viewport of the IgxScroll is scrolled.
     * @type {EventEmitter<IgxScrollEvent>}
     */
    onScroll: EventEmitter<IgxScrollEvent>;
    private verticalScroll;
    private animationFrameId;
    private velocityY;
    private amplitude;
    private timestamp;
    private target;
    /**
     * Scroll with the given delta. Does not scrolls when the scroll delta is outside of the scroll boundaries
     * @param delta
     */
    scrollVertically(delta: number): void;
    readonly totalHeight: string;
    readonly innerHeight: string;
    onMouseWheel($event: any): void;
    onPan($event: any): void;
    onScrolled($event: any): void;
    private run(timeStamp);
    private emitScroll();
}
export declare class IgxScrollModule {
}
