import { Component, EventEmitter, Input, NgModule, Output, ViewChild } from "@angular/core";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
var noop = function () { };
var ɵ0 = noop;
var nextId = 0;
var IgxSwitch = (function () {
    function IgxSwitch() {
        this.id = "igx-switch-" + nextId++;
        this.disabled = false;
        this.tabindex = null;
        this.checked = false;
        this.change = new EventEmitter();
        this.focused = false;
        this._onTouchedCallback = noop;
        this._onChangeCallback = noop;
    }
    Object.defineProperty(IgxSwitch.prototype, "labelId", {
        get: function () {
            return this.id + "_label";
        },
        enumerable: true,
        configurable: true
    });
    IgxSwitch.prototype.onChange = function (event) {
        if (this.disabled) {
            return;
        }
        this.checked = !this.checked;
        this._onChangeCallback(this.checked);
        this.change.emit(event);
    };
    IgxSwitch.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxSwitch.prototype.onBlur = function (event) {
        this.focused = false;
        this._onTouchedCallback();
    };
    IgxSwitch.prototype.writeValue = function (value) {
        if (this.disabled) {
            return;
        }
        this._value = value;
        this.checked = this._value;
    };
    IgxSwitch.prototype.registerOnChange = function (fn) { this._onChangeCallback = fn; };
    IgxSwitch.prototype.registerOnTouched = function (fn) { this._onTouchedCallback = fn; };
    IgxSwitch.decorators = [
        { type: Component, args: [{
                    providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: IgxSwitch, multi: true }],
                    selector: "igx-switch",
                    styles: ["\n      .igx-control__switch ~ .igx-control__label{display:inline-block;position:relative;width:35px;height:14px;background-color:rgba(0,0,0,0.54);color:transparent;border-radius:100px;cursor:pointer;-webkit-transition:all 0.2s ease-in;transition:all 0.2s ease-in;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.igx-control__switch ~ .igx-control__label::after{display:block;position:absolute;content:'';width:20px;height:20px;top:-3px;left:-1px;border-radius:100px;background:#fff;-webkit-box-shadow:0 1px 3px 0 rgba(0,0,0,0.26),0 1px 1px 0 rgba(0,0,0,0.12),0 2px 1px -1px rgba(0,0,0,0.08);box-shadow:0 1px 3px 0 rgba(0,0,0,0.26),0 1px 1px 0 rgba(0,0,0,0.12),0 2px 1px -1px rgba(0,0,0,0.08);-webkit-transition:all 0.2s ease-in;transition:all 0.2s ease-in}.igx-control__switch:checked ~ .igx-control__label{background-color:rgba(228,28,119,0.5)}.igx-control__switch:checked ~ .igx-control__label::after{left:16px;background:#e41c77}.igx-control__switch:disabled ~ .igx-control__label{background:rgba(0,0,0,0.04);pointer-events:none}.igx-control__switch:disabled ~ .igx-control__label::after{background:rgba(0,0,0,0.26);-webkit-box-shadow:0 1px 3px 0 rgba(0,0,0,0.26),0 1px 1px 0 rgba(0,0,0,0.12),0 2px 1px -1px rgba(0,0,0,0.08);box-shadow:0 1px 3px 0 rgba(0,0,0,0.26),0 1px 1px 0 rgba(0,0,0,0.12),0 2px 1px -1px rgba(0,0,0,0.08)}.igx-control{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;padding:8px 0}.igx-control__switch{margin:0;position:absolute;opacity:0;z-index:-1;width:0;height:0;left:0;overflow:hidden;pointer-events:none}.igx-control__switch-text{padding-right:1em}\n    "],
                    template: "\n      <div class=\"igx-control\">\n          <input class=\"igx-control__switch\" #checkbox type=\"checkbox\" role=\"checkbox\"\n              [attr.id]=\"id\"\n              [attr.name]=\"name\"\n              [attr.value]=\"value\"\n              [attr.tabindex]=\"tabindex\"\n              [disabled]=\"disabled\"\n              [checked]=\"checked\"\n              [attr.aria-checked]=\"checked\"\n              [attr.aria-labelledby]=\"labelId\"\n              (change)=\"onChange($event)\"\n              (focus)=\"onFocus($event)\"\n              (blur)=\"onBlur($event)\">\n          <span class=\"igx-control__text\" [attr.id]=\"labelId\"><ng-content></ng-content>\n          </span>\n          <label class =\"igx-control__label\" [attr.for]=\"id\"></label>\n      </div>\n    "
                },] },
    ];
    /** @nocollapse */
    IgxSwitch.ctorParameters = function () { return []; };
    IgxSwitch.propDecorators = {
        "value": [{ type: Input },],
        "id": [{ type: Input },],
        "labelId": [{ type: Input },],
        "name": [{ type: Input },],
        "disabled": [{ type: Input },],
        "tabindex": [{ type: Input },],
        "checked": [{ type: Input },],
        "change": [{ type: Output },],
        "nativeCheckbox": [{ type: ViewChild, args: ["checkbox",] },],
    };
    return IgxSwitch;
}());
export { IgxSwitch };
var IgxSwitchModule = (function () {
    function IgxSwitchModule() {
    }
    IgxSwitchModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxSwitch],
                    exports: [IgxSwitch]
                },] },
    ];
    /** @nocollapse */
    IgxSwitchModule.ctorParameters = function () { return []; };
    return IgxSwitchModule;
}());
export { IgxSwitchModule };
export { ɵ0 };
//# sourceMappingURL=switch.component.js.map